<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTextMessageOutbox_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTextMessageOutbox_V4 extends AbstractStructArrayBase
{
    /**
     * The TextMessageOutbox_V4
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TextMessageOutbox_V4[]
     */
    public $TextMessageOutbox_V4;
    /**
     * Constructor method for ArrayOfTextMessageOutbox_V4
     * @uses ArrayOfTextMessageOutbox_V4::setTextMessageOutbox_V4()
     * @param \StructType\TextMessageOutbox_V4[] $textMessageOutbox_V4
     */
    public function __construct(array $textMessageOutbox_V4 = array())
    {
        $this
            ->setTextMessageOutbox_V4($textMessageOutbox_V4);
    }
    /**
     * Get TextMessageOutbox_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TextMessageOutbox_V4[]|null
     */
    public function getTextMessageOutbox_V4()
    {
        return isset($this->TextMessageOutbox_V4) ? $this->TextMessageOutbox_V4 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTextMessageOutbox_V4 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTextMessageOutbox_V4 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTextMessageOutbox_V4ForArrayConstraintsFromSetTextMessageOutbox_V4(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTextMessageOutbox_V4TextMessageOutbox_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfTextMessageOutbox_V4TextMessageOutbox_V4Item instanceof \StructType\TextMessageOutbox_V4) {
                $invalidValues[] = is_object($arrayOfTextMessageOutbox_V4TextMessageOutbox_V4Item) ? get_class($arrayOfTextMessageOutbox_V4TextMessageOutbox_V4Item) : sprintf('%s(%s)', gettype($arrayOfTextMessageOutbox_V4TextMessageOutbox_V4Item), var_export($arrayOfTextMessageOutbox_V4TextMessageOutbox_V4Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TextMessageOutbox_V4 property can only contain items of type \StructType\TextMessageOutbox_V4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TextMessageOutbox_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageOutbox_V4[] $textMessageOutbox_V4
     * @return \ArrayType\ArrayOfTextMessageOutbox_V4
     */
    public function setTextMessageOutbox_V4(array $textMessageOutbox_V4 = array())
    {
        // validation for constraint: array
        if ('' !== ($textMessageOutbox_V4ArrayErrorMessage = self::validateTextMessageOutbox_V4ForArrayConstraintsFromSetTextMessageOutbox_V4($textMessageOutbox_V4))) {
            throw new \InvalidArgumentException($textMessageOutbox_V4ArrayErrorMessage, __LINE__);
        }
        if (is_null($textMessageOutbox_V4) || (is_array($textMessageOutbox_V4) && empty($textMessageOutbox_V4))) {
            unset($this->TextMessageOutbox_V4);
        } else {
            $this->TextMessageOutbox_V4 = $textMessageOutbox_V4;
        }
        return $this;
    }
    /**
     * Add item to TextMessageOutbox_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageOutbox_V4 $item
     * @return \ArrayType\ArrayOfTextMessageOutbox_V4
     */
    public function addToTextMessageOutbox_V4(\StructType\TextMessageOutbox_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TextMessageOutbox_V4) {
            throw new \InvalidArgumentException(sprintf('The TextMessageOutbox_V4 property can only contain items of type \StructType\TextMessageOutbox_V4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TextMessageOutbox_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TextMessageOutbox_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TextMessageOutbox_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TextMessageOutbox_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TextMessageOutbox_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TextMessageOutbox_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TextMessageOutbox_V4
     */
    public function getAttributeName()
    {
        return 'TextMessageOutbox_V4';
    }
}
